Index: greenstone3/trunk/web/interfaces/gs2/transform/style.xsl
===================================================================
--- greenstone3/trunk/web/interfaces/gs2/transform/style.xsl	(revision 18318)
+++ greenstone3/trunk/web/interfaces/gs2/transform/style.xsl	(revision 18391)
@@ -7,4 +7,6 @@
   exclude-result-prefixes="java util">
   
+  <xsl:include href="icons.xsl"/>
+
   <!-- some global parameters - these are set by whoever is invoking the transformation -->
   <xsl:param name="interface_name"/>
@@ -13,6 +15,6 @@
   <!-- any global style stuff should go in here -->
   <xsl:template name="globalStyle">
-    <link rel="stylesheet" href="interfaces/gs2/style/classic.css" type="text/css"/>
-    <link rel="stylesheet" href="interfaces/gs2/style/classic2.css" type="text/css"/>
+    <link rel="stylesheet" href="interfaces/gs2/style/gs2-style.css" type="text/css"/>
+    <link rel="stylesheet" href="interfaces/gs2/style/gs2-style2.css" type="text/css"/>
   </xsl:template>
   
@@ -228,127 +230,8 @@
   </xsl:template>
   
-  <xsl:template name="nzdlPageBanner">
-    <div><img src="interfaces/nzdl/images/nzdl2gr.gif" width="457" height="181" ><xsl:attribute name="alt"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'nzdl')"/></xsl:attribute></img></div>
-    <!-- end of page banner -->  
-  </xsl:template>
-
   <xsl:template name="greenstoneFooter">
     <div class="divbar"><p class="navbar">powered by greenstone3</p>
     </div>
-  </xsl:template>
-  
-  <xsl:template name="imagegreenstone">
-    <img src="interfaces/nzdl/images/gsdl.gif" width="140" height="77" border="0" hspace='0'><xsl:attribute name='alt'><xsl:call-template name='textimagegreenstone'/></xsl:attribute></img>
-  </xsl:template>
-  
-  <!-- Display the appropriate image, depending on the node type -->
-  <xsl:template match="documentNode" mode="displayNodeIcon">
-    
-    <!-- Root node: book icon (open or closed) -->
-    <xsl:choose>
-      <xsl:when test="@nodeType='root'">
-	<xsl:choose>
-	  <xsl:when test="documentNode">
-	    <xsl:call-template name="openbookimg">
-	      <xsl:with-param name="title">Close this book</xsl:with-param>
-	    </xsl:call-template>
-	  </xsl:when>
-	  <xsl:otherwise>
-	    <xsl:call-template name="closedbookimg">
-	      <xsl:with-param name="title">Open this document and view contents</xsl:with-param>
-	    </xsl:call-template>
-	  </xsl:otherwise>
-	</xsl:choose>
-      </xsl:when>
-      
-      <!-- Internal node: folder icon (open or closed) -->
-      <xsl:when test="@nodeType='internal'">
-	<xsl:choose>
-	  <xsl:when test="documentNode">
-	    <xsl:call-template name="openfolderimg">
-	      <xsl:with-param name="title">Close this folder</xsl:with-param>
-	    </xsl:call-template>
-	  </xsl:when>
-	  <xsl:otherwise>
-	    <xsl:call-template name="closedfolderimg">
-	      <xsl:with-param name="title">Open this folder and view contents</xsl:with-param>
-	    </xsl:call-template>
-	  </xsl:otherwise>
-	</xsl:choose>
-      </xsl:when>
-      
-      <!-- Leaf node: page icon, and this is the default -->
-      <xsl:otherwise>
-	<xsl:call-template name="textpageimg">
-	  <xsl:with-param name="title">View the document</xsl:with-param>
-	</xsl:call-template>
-      </xsl:otherwise>
-    </xsl:choose>
-  </xsl:template>
-
-
-  <xsl:template name="openbookimg">
-    <xsl:param name="alt"/>
-    <xsl:param name="title"/>
-    <img border="0" width="28" height="23" 
-      src="interfaces/default/images/openbook.gif"
-      alt="{$alt}" title="{$title}"/>
-  </xsl:template>
-
-  <xsl:template name="closedbookimg">
-    <xsl:param name="alt"/>
-    <xsl:param name="title"/>
-    <img border="0" width="18" height="11"  
-      src="interfaces/default/images/book.gif"
-      alt="{$alt}" title="{$title}"/>
-  </xsl:template>
-
-  <xsl:template name="openfolderimg">
-    <xsl:param name="alt"/>
-    <xsl:param name="title"/>
-    <img border="0" width="23" height="15"  
-      src="interfaces/default/images/openfldr.gif"
-      alt="{$alt}" title="{$title}"/>
-  </xsl:template>
-
-  <xsl:template name="closedfolderimg">
-    <xsl:param name="alt"/>
-    <xsl:param name="title"/>
-    <img border="0" width="23" height="15" 
-      src="interfaces/default/images/clsdfldr.gif"
-      alt="{$alt}" title="{$title}"/>
-  </xsl:template>
-
-  <xsl:template name="textpageimg">
-    <xsl:param name="alt"/>
-    <xsl:param name="title"/>
-    <img border="0" width="16" height="21"
-      src="interfaces/default/images/itext.gif"
-      alt="{$alt}" title="{$title}"/>
-  </xsl:template>
-
-  <xsl:template name="bookshelfimg">
-    <xsl:param name="alt"/>
-    <xsl:param name="title"/>
-    <img border="0" width="20" height="16" 
-      src="interfaces/default/images/bshelf.gif"  
-      alt="{$alt}" title="{$title}"/>
-  </xsl:template>
-
-  <xsl:template name="iconpdf">
-    <xsl:param name="alt">PDF</xsl:param>
-    <xsl:param name="title"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'texticonpdf')"/></xsl:param>
-    <img border="0" width='26' height='26' 
-      src='interfaces/default/images/ipdf.gif' 
-      alt='{$alt}' title='{$title}'/>
-  </xsl:template>
-  
-  <xsl:template name="icondoc">
-    <xsl:param name="alt">Word</xsl:param>
-    <xsl:param name="title"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'texticonmsword')"/></xsl:param>
-    <img border="0" width='26' height='26' 
-      src='interfaces/default/images/imsword.gif' 
-      alt='{$alt}' title='{$title}'/>
-  </xsl:template>
+  </xsl:template>  
 
   <xsl:template name="direction">