Index: /greenstone3/trunk/web/interfaces/gs2/transform/about.xsl
===================================================================
--- /greenstone3/trunk/web/interfaces/gs2/transform/about.xsl	(revision 18391)
+++ /greenstone3/trunk/web/interfaces/gs2/transform/about.xsl	(revision 18392)
@@ -25,7 +25,7 @@
 	<xsl:call-template name="pageStyle"/>
       </head>
-      <body class="bgimage">
+      <body>
 	<xsl:attribute name="dir"><xsl:call-template name="direction"/></xsl:attribute>
-	<div id="page">
+	<div id="page-wrapper">
 	  <xsl:apply-templates select="pageResponse"/>
 	  <xsl:call-template name="greenstoneFooter"/>                	   
Index: /greenstone3/trunk/web/interfaces/gs2/transform/applet.xsl
===================================================================
--- /greenstone3/trunk/web/interfaces/gs2/transform/applet.xsl	(revision 18391)
+++ /greenstone3/trunk/web/interfaces/gs2/transform/applet.xsl	(revision 18392)
@@ -23,7 +23,7 @@
 	<xsl:call-template name="pageStyle"/>
       </head>
-      <body class="bgimage">
+      <body>
 	<xsl:attribute name="dir"><xsl:call-template name="direction"/></xsl:attribute>
-	<div id="page">
+	<div id="page-wrapper">
 	  <xsl:apply-templates select="pageResponse"/>
 	  <xsl:call-template name="greenstoneFooter"/>                	   
Index: /greenstone3/trunk/web/interfaces/gs2/transform/classifier.xsl
===================================================================
--- /greenstone3/trunk/web/interfaces/gs2/transform/classifier.xsl	(revision 18391)
+++ /greenstone3/trunk/web/interfaces/gs2/transform/classifier.xsl	(revision 18392)
@@ -24,7 +24,7 @@
 	<xsl:call-template name="pageStyle"/>
       </head>
-      <body class="bgimage">
+      <body>
 	<xsl:attribute name="dir"><xsl:call-template name="direction"/></xsl:attribute>
-	<div id="page">
+	<div id="page-wrapper">
 	  <xsl:apply-templates select="pageResponse"/>
 	  <xsl:call-template name="greenstoneFooter"/>                	   
Index: /greenstone3/trunk/web/interfaces/gs2/transform/document.xsl
===================================================================
--- /greenstone3/trunk/web/interfaces/gs2/transform/document.xsl	(revision 18391)
+++ /greenstone3/trunk/web/interfaces/gs2/transform/document.xsl	(revision 18392)
@@ -25,7 +25,7 @@
 	<xsl:call-template name="pageStyle"/>
       </head>
-      <body>
+      <body style="background-image: none;">
         <xsl:attribute name="dir"><xsl:call-template name="direction"/></xsl:attribute>
-        <div id="page">
+        <div id="page-wrapper">
 	  <xsl:apply-templates select="pageResponse"/>
 	  <xsl:call-template name="greenstoneFooter"/>
Index: /greenstone3/trunk/web/interfaces/gs2/transform/gli4gs3.xsl
===================================================================
--- /greenstone3/trunk/web/interfaces/gs2/transform/gli4gs3.xsl	(revision 18391)
+++ /greenstone3/trunk/web/interfaces/gs2/transform/gli4gs3.xsl	(revision 18392)
@@ -23,7 +23,7 @@
 	<xsl:call-template name="pageStyle"/>
       </head>
-      <body class="bgimage">
+      <body>
 	<xsl:attribute name="dir"><xsl:call-template name="direction"/></xsl:attribute>
-	<div id="page">
+	<div id="page-wrapper">
 	  <xsl:apply-templates select="pageResponse"/>
 	  <xsl:call-template name="greenstoneFooter"/>                	   
Index: /greenstone3/trunk/web/interfaces/gs2/transform/help.xsl
===================================================================
--- /greenstone3/trunk/web/interfaces/gs2/transform/help.xsl	(revision 18391)
+++ /greenstone3/trunk/web/interfaces/gs2/transform/help.xsl	(revision 18392)
@@ -25,7 +25,7 @@
 	<xsl:call-template name="pageStyle"/>
       </head>
-      <body class="bgimage">
+      <body>
 	<xsl:attribute name="dir"><xsl:call-template name="direction"/></xsl:attribute>
-	<div id="page">
+	<div id="page-wrapper">
 	  <xsl:apply-templates select="pageResponse"/>
 	  <xsl:call-template name="greenstoneFooter"/>                	   
Index: /greenstone3/trunk/web/interfaces/gs2/transform/home.xsl
===================================================================
--- /greenstone3/trunk/web/interfaces/gs2/transform/home.xsl	(revision 18391)
+++ /greenstone3/trunk/web/interfaces/gs2/transform/home.xsl	(revision 18392)
@@ -23,7 +23,7 @@
 	<xsl:call-template name="pageStyle"/>
       </head>
-      <body class="bgimage">
+      <body>
 	<xsl:attribute name="dir"><xsl:call-template name="direction"/></xsl:attribute>
-	<div id="page">
+	<div id="page-wrapper">
 	  <xsl:apply-templates select="pageResponse"/>
 	  <xsl:call-template name="greenstoneFooter"/>                	   
Index: /greenstone3/trunk/web/interfaces/gs2/transform/pref.xsl
===================================================================
--- /greenstone3/trunk/web/interfaces/gs2/transform/pref.xsl	(revision 18391)
+++ /greenstone3/trunk/web/interfaces/gs2/transform/pref.xsl	(revision 18392)
@@ -22,7 +22,7 @@
 	<xsl:call-template name="pageStyle"/>
       </head>
-      <body class="bgimage">
+      <body>
 	<xsl:attribute name="dir"><xsl:call-template name="direction"/></xsl:attribute>
-	<div id="page">
+	<div id="page-wrapper">
 	  <xsl:apply-templates select="pageResponse"/>
 	  <xsl:call-template name="greenstoneFooter"/>                	   
@@ -39,5 +39,4 @@
   <xsl:template name="pageStyle">
     <script type="text/javascript" src="interfaces/gs2/js/pref.js"><xsl:text disable-output-escaping="yes"> </xsl:text></script>
-    <link rel="stylesheet" href="interfaces/gs2/style/classic.css" type="text/css"/>
   </xsl:template>
 
Index: /greenstone3/trunk/web/interfaces/gs2/transform/query.xsl
===================================================================
--- /greenstone3/trunk/web/interfaces/gs2/transform/query.xsl	(revision 18391)
+++ /greenstone3/trunk/web/interfaces/gs2/transform/query.xsl	(revision 18392)
@@ -25,7 +25,7 @@
 	<xsl:call-template name="pageStyle"/>
       </head>
-      <body class="bgimage">
+      <body>
 	<xsl:attribute name="dir"><xsl:call-template name="direction"/></xsl:attribute>
-	<div id="page">
+	<div id="page-wrapper">
 	  <xsl:apply-templates select="pageResponse"/>
 	  <xsl:call-template name="greenstoneFooter"/>                	   