Index: /gsdl/trunk/perllib/plugins/BasePlugin.pm
===================================================================
--- /gsdl/trunk/perllib/plugins/BasePlugin.pm	(revision 18403)
+++ /gsdl/trunk/perllib/plugins/BasePlugin.pm	(revision 18404)
@@ -52,6 +52,6 @@
       { 'name' => "base64",
 	'desc' => "{BasePlugin.rename_method.base64}" }, 
-      { 'name' => "inherited",
-	'desc' => "{BasePlugin.rename_method.inherited}", 
+      { 'name' => "none",
+	'desc' => "{BasePlugin.rename_method.none}", 
 	'hiddengli' => "yes" } ];
 
@@ -776,5 +776,5 @@
     # If using URL encoding, then SourceFile is the url-reference to url-encoded
     # filemeta: it's a url that refers to the actual file on the system
-    $filemeta = &unicode::filename_to_url($filemeta, $self->{'file_rename_method'});
+    $filemeta = &unicode::filename_to_url($filemeta);
 
     $doc_obj->set_utf8_metadata_element($top_section, "SourceFile", $filemeta);
@@ -1043,5 +1043,5 @@
 		# If the filename is url_encoded, we need to encode the % signs 
 		# in the filename, so that it works in a url
-		my $url_tail_filename = &unicode::filename_to_url($tail_filename, $self->{'file_rename_method'});
+		my $url_tail_filename = &unicode::filename_to_url($tail_filename);
 		# work out extended tail extension (i.e. matching tail re)
 
Index: /gsdl/trunk/perllib/plugins/HTMLPlugin.pm
===================================================================
--- /gsdl/trunk/perllib/plugins/HTMLPlugin.pm	(revision 18403)
+++ /gsdl/trunk/perllib/plugins/HTMLPlugin.pm	(revision 18404)
@@ -1149,5 +1149,5 @@
 	# of filenames, URL-encode the additional percent signs of the URL-encoded filename
 	my $newname_url = $newname;
-	$newname_url = &unicode::filename_to_url($newname_url, $self->{'file_rename_method'});
+	$newname_url = &unicode::filename_to_url($newname_url);
 	return "_httpdocimg_/$newname_url";	
     }
Index: /gsdl/trunk/perllib/plugins/ImageConverter.pm
===================================================================
--- /gsdl/trunk/perllib/plugins/ImageConverter.pm	(revision 18403)
+++ /gsdl/trunk/perllib/plugins/ImageConverter.pm	(revision 18404)
@@ -188,6 +188,6 @@
     # The images that will get generated may contain percent signs in their src filenames
     # Encode those percent signs themselves so that urls to the imgs refer to them correctly 
-    my $url_to_filehead = &unicode::filename_to_url($filehead, $self->{'file_rename_method'});
-    my $url_to_filename_no_path = &unicode::filename_to_url($filename_no_path, $self->{'file_rename_method'});
+    my $url_to_filehead = &unicode::filename_to_url($filehead);
+    my $url_to_filename_no_path = &unicode::filename_to_url($filename_no_path);
     
     # Convert the image to a new type (if required).
Index: /gsdl/trunk/perllib/strings.properties
===================================================================
--- /gsdl/trunk/perllib/strings.properties	(revision 18403)
+++ /gsdl/trunk/perllib/strings.properties	(revision 18404)
@@ -722,4 +722,6 @@
 BasePlugin.rename_method.base64:Use base64 encoding in renaming imported files and associated files.
 
+BasePlugin.rename_method.none:Don't rename imported files and associated files.
+
 BibTexPlugin.desc:BibTexPlugin reads bibliography files in BibTex format. BibTexPlugin creates a document object for every reference in the file. It is a subclass of SplitTextFile, so if there are multiple records, all are read.
 
Index: /gsdl/trunk/perllib/unicode.pm
===================================================================
--- /gsdl/trunk/perllib/unicode.pm	(revision 18403)
+++ /gsdl/trunk/perllib/unicode.pm	(revision 18404)
@@ -620,10 +620,8 @@
 # a url more than once this way.
 sub filename_to_url {
-    my ($text, $rename_method) = @_;
-    
-    if(!defined $rename_method || $rename_method eq "url") {
-	if($text !~ m/%25/) {
-	    $text =~ s/%/%25/g;
-	}
+    my ($text) = @_;
+    
+    if($text !~ m/%25/) {
+	$text =~ s/%/%25/g;
     }
     return $text;
Index: /gsdl/trunk/perllib/util.pm
===================================================================
--- /gsdl/trunk/perllib/util.pm	(revision 18403)
+++ /gsdl/trunk/perllib/util.pm	(revision 18404)
@@ -1026,4 +1026,6 @@
 	my ($cpackage,$cfilename,$cline,$csubr,$chas_args,$cwantarray) = caller(1);
 	print STDERR "Calling method: $cfilename:$cline $cpackage->$csubr\n";
+    } elsif($rename_method eq "none") {
+	return $filename; # would have already been renamed
     }
 