Index: gsdl/trunk/perllib/plugins/CONTENTdmPlugin.pm
===================================================================
--- gsdl/trunk/perllib/plugins/CONTENTdmPlugin.pm	(revision 18404)
+++ gsdl/trunk/perllib/plugins/CONTENTdmPlugin.pm	(revision 18406)
@@ -131,5 +131,5 @@
     push(@$pagedimg_options, "-title_sub", '^(Page\s+\d+)?(\s*1\s+)?');
     push(@$pagedimg_options, "-create_thumbnail", "true", "-create_screenview", "true");
-
+    push(@$pagedimg_options, "-file_rename_method", "none");
 
     $self = bless $self, $class;
Index: gsdl/trunk/perllib/plugins/ExcelPlugin.pm
===================================================================
--- gsdl/trunk/perllib/plugins/ExcelPlugin.pm	(revision 18404)
+++ gsdl/trunk/perllib/plugins/ExcelPlugin.pm	(revision 18406)
@@ -73,8 +73,18 @@
 	$secondary_plugin_options->{'HTMLPlugin'} = [];
     }
+    if (!defined $secondary_plugin_options->{'TextPlugin'}) {
+	$secondary_plugin_options->{'TextPlugin'} = [];
+    }
     my $html_options = $secondary_plugin_options->{'HTMLPlugin'};
-    
+    my $text_options = $secondary_plugin_options->{'TextPlugin'};
+
     push(@$html_options, "-input_encoding", "utf8");
     push(@$html_options,"-extract_language") if $self->{'extract_language'};
+    push(@$html_options, "-file_rename_method", "none");
+    
+    push(@$text_options, "-input_encoding", "utf8");
+    push(@$text_options,"-extract_language") if $self->{'extract_language'};
+    push(@$text_options, "-file_rename_method", "none");
+
     $self = bless $self, $class;
     
Index: gsdl/trunk/perllib/plugins/PDFPlugin.pm
===================================================================
--- gsdl/trunk/perllib/plugins/PDFPlugin.pm	(revision 18404)
+++ gsdl/trunk/perllib/plugins/PDFPlugin.pm	(revision 18406)
@@ -186,8 +186,11 @@
 	push(@$html_options, "-associate_tail_re", $associate_tail_re);
 	push(@$text_options, "-associate_tail_re", $associate_tail_re);
-	push(@$pagedimg_options, "-associate_tail_re", $associate_tail_re);
-    }
-
- 
+	push(@$pagedimg_options, "-associate_tail_re", $associate_tail_re) if defined $pagedimg_options;
+    }
+
+    push(@$html_options, "-file_rename_method", "none");
+    push(@$text_options, "-file_rename_method", "none");
+    push(@$pagedimg_options, "-file_rename_method", "none") if defined $pagedimg_options;
+
     $self = bless $self, $class;
     $self->load_secondary_plugins($class,$secondary_plugin_options,$hashArgOptLists);
Index: gsdl/trunk/perllib/plugins/PostScriptPlugin.pm
===================================================================
--- gsdl/trunk/perllib/plugins/PostScriptPlugin.pm	(revision 18404)
+++ gsdl/trunk/perllib/plugins/PostScriptPlugin.pm	(revision 18406)
@@ -112,11 +112,17 @@
     }
 
+    if (!defined $secondary_plugin_options->{'HTMLPlugin'}) {
+	$secondary_plugin_options->{'HTMLPlugin'} = [];
+    }
+
     my $text_options = $secondary_plugin_options->{'TextPlugin'};
-
-    if (defined $self->{'convert_to'} && $self->{'convert_to'} =~ /pagedimg.*/i) {
+    my $html_options = $secondary_plugin_options->{'HTMLPlugin'};
+
+    if (defined $self->{'convert_to'} && $self->{'convert_to'} =~ m/(pagedimage|pagedimg).*/i) {
 	if (!defined $secondary_plugin_options->{'PagedImagePlugin'}){
 	    $secondary_plugin_options->{'PagedImagePlugin'} = [];
 	    my $pagedimg_options = $secondary_plugin_options->{'PagedImagePlugin'}; 
 	    push(@$pagedimg_options, "-title_sub", '^(Page\s+\d+)?(\s*1\s+)?');
+	    push(@$pagedimg_options, "-file_rename_method", "none");
 	}
     }
@@ -130,4 +136,7 @@
     push(@$text_options , "-title_sub", '^(Page\s+\d+)?(\s*1\s+)?');
 
+    push(@$text_options, "-file_rename_method", "none");
+    push(@$html_options, "-file_rename_method", "none");
+    
     $self = bless $self, $class;
     # used for convert_post_process
Index: gsdl/trunk/perllib/plugins/PowerPointPlugin.pm
===================================================================
--- gsdl/trunk/perllib/plugins/PowerPointPlugin.pm	(revision 18404)
+++ gsdl/trunk/perllib/plugins/PowerPointPlugin.pm	(revision 18406)
@@ -106,15 +106,18 @@
     my $secondary_plugin_options = $self->{'secondary_plugin_options'};
 
-    if ($self->{'windows_scripting'} && ($self->{'convert_to'} eq "PagedImg")) {
+    if ($self->{'windows_scripting'} && ($self->{'convert_to'} =~ m/(pagedimage|pagedimg).*/i)) {
 	$secondary_plugin_options->{'PagedImagePlugin'} = [];
     } else {
 	$secondary_plugin_options->{'HTMLPlugin'} = [];
+	$secondary_plugin_options->{'TextPlugin'} = [];
     }
     my $html_options = $secondary_plugin_options->{'HTMLPlugin'};
+    my $text_options = $secondary_plugin_options->{'TextPlugin'};
     my $pageimg_options = $secondary_plugin_options->{'PagedImagePlugin'};
  
-    if (defined $secondary_plugin_options->{'HTMLPlugin'}){
+    if (defined $html_options){
 	push(@$html_options,"-input_encoding", "utf8");
 	push(@$html_options,"-extract_language") if $self->{'extract_language'};
+	push(@$html_options,"-file_rename_method", "none");
 	
 	# Instruct HTMLPlugin (when eventually accessed through read_into_doc_obj) 
@@ -122,7 +125,13 @@
 	push(@$html_options,"-metadata_fields","Title,GENERATOR,date,author<Creator>");
     } 
-    if (defined $secondary_plugin_options->{'PagedImagePlugin'}){
+    if (defined $text_options){
+	push(@$text_options,"-input_encoding", "utf8");
+	push(@$text_options,"-extract_language") if $self->{'extract_language'};
+	push(@$text_options,"-file_rename_method", "none");
+    }
+    if (defined $pageimg_options){
 	push(@$pageimg_options,"-input_encoding", "utf8");
-	push(@$pageimg_options,"-extract_language") if $self->{'extract_language'};
+	push(@$pageimg_options,"-extract_language") if $self->{'extract_language'};	
+	push(@$pageimg_options,"-file_rename_method", "none");
     }
 
Index: gsdl/trunk/perllib/plugins/RTFPlugin.pm
===================================================================
--- gsdl/trunk/perllib/plugins/RTFPlugin.pm	(revision 18404)
+++ gsdl/trunk/perllib/plugins/RTFPlugin.pm	(revision 18406)
@@ -88,4 +88,7 @@
     push(@$html_options,"-extract_language") if $self->{'extract_language'};
 
+    push(@$html_options, "-file_rename_method", "none");
+    push(@$text_options, "-file_rename_method", "none");
+
     $self = bless $self, $class;
 
Index: gsdl/trunk/perllib/plugins/WordPlugin.pm
===================================================================
--- gsdl/trunk/perllib/plugins/WordPlugin.pm	(revision 18404)
+++ gsdl/trunk/perllib/plugins/WordPlugin.pm	(revision 18406)
@@ -131,8 +131,8 @@
 	    # Instruct HTMLPlugin (when eventually accessed through read_into_doc_obj)
 	    # to extract these metadata fields from the HEAD META fields
-	    push (@$structhtml_options,"-metadata_fields","Title,GENERATOR,date,author<Creator>");
-	    push (@$structhtml_options , "-title_sub", '^(Page\s+\d+)?(\s*1\s+)?');
+	    push (@$structhtml_options, "-metadata_fields","Title,GENERATOR,date,author<Creator>");
+	    push (@$structhtml_options, "-title_sub", '^(Page\s+\d+)?(\s*1\s+)?');
 	    push (@$structhtml_options, "-description_tags") if $self->{'windows_scripting'};
-	    push(@$structhtml_options,"-extract_language") if $self->{'extract_language'};
+	    push (@$structhtml_options, "-extract_language") if $self->{'extract_language'};
 	    push (@$structhtml_options, "-delete_toc") if $self->{'delete_toc'};
 	    push (@$structhtml_options, "-toc_header", $self->{'toc_header'}) if $self->{'toc_header'};
@@ -168,7 +168,11 @@
 	push(@$html_options, "-associate_tail_re", $associate_tail_re);
 	push(@$text_options, "-associate_tail_re", $associate_tail_re);
-	push(@$structhtml_options, "-associate_tail_re", $associate_tail_re);
-    }
-       
+	push(@$structhtml_options, "-associate_tail_re", $associate_tail_re) if defined $structhtml_options;
+    }
+
+    push(@$html_options, "-file_rename_method", "none");
+    push(@$text_options, "-file_rename_method", "none");
+    push(@$structhtml_options, "-file_rename_method", "none") if defined $structhtml_options;
+
     $self = bless $self, $class;
     $self->load_secondary_plugins($class,$secondary_plugin_options,$hashArgOptLists);