Index: /gli/trunk/src/org/greenstone/gatherer/cdm/DepositorMetadataManager.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/cdm/DepositorMetadataManager.java	(revision 18413)
+++ /gli/trunk/src/org/greenstone/gatherer/cdm/DepositorMetadataManager.java	(revision 18414)
@@ -342,9 +342,10 @@
 	    // the checkbox component
 	    enabled = new JCheckBox(entry.name);
+	    enabled.setComponentOrientation(Dictionary.getOrientation());
 	    enabled.setSelected(entry.selected);
 	    enabled.setOpaque(false);
 	    enabled.setPreferredSize(LABEL_SIZE);
 	    enabled.setToolTipText(entry.tooltip);
-	    add(enabled, BorderLayout.WEST);
+	    add(enabled, BorderLayout.LINE_START);
 			
 	    // the drop down list component
@@ -354,4 +355,5 @@
 	    }
 	    value_control = new GComboBox(option_list.toArray(), false, false);
+	    value_control.setComponentOrientation(Dictionary.getOrientation());
 	    selectValue((JComboBox)value_control, entry.type); 
 	    value_control.setOpaque(true);			
Index: /gli/trunk/src/org/greenstone/gatherer/cdm/FormatManager.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/cdm/FormatManager.java	(revision 18413)
+++ /gli/trunk/src/org/greenstone/gatherer/cdm/FormatManager.java	(revision 18414)
@@ -313,4 +313,5 @@
     
     public FormatControl() {
+      this.setComponentOrientation(Dictionary.getOrientation());
       feature_model = buildFeatureModel();
       part_model = buildPartModel();
@@ -324,7 +325,12 @@
       selection_pane = new JPanel();
       JPanel feature_pane = new JPanel();
+      feature_pane.setComponentOrientation(Dictionary.getOrientation());
+
       JLabel feature_label = new JLabel(Dictionary.get("CDM.FormatManager.Feature"));
-      
+      feature_label.setComponentOrientation(Dictionary.getOrientation());
+
       feature_combobox = new JComboBox(feature_model.toArray());
+      feature_combobox.setComponentOrientation(Dictionary.getOrientation());
+
       feature_combobox.setOpaque(!Utility.isMac());
       feature_combobox.setPreferredSize(FIELD_SIZE);
@@ -333,6 +339,9 @@
       
       part_pane = new JPanel();
+      part_pane.setComponentOrientation(Dictionary.getOrientation());
       JLabel part_label = new JLabel(Dictionary.get("CDM.FormatManager.Part"));
+      part_label.setComponentOrientation(Dictionary.getOrientation());
       part_combobox = new JComboBox(part_model.toArray());
+      part_combobox.setComponentOrientation(Dictionary.getOrientation());
       part_combobox.setOpaque(!Utility.isMac());
       part_combobox.setPreferredSize(FIELD_SIZE);
@@ -352,4 +361,5 @@
       JPanel editor_header_pane = new JPanel();
       JLabel editor_label = new JLabel(Dictionary.get("CDM.FormatManager.Editor"));
+      editor_label.setComponentOrientation(Dictionary.getOrientation());
       
       editor_textarea = new JTextArea();
@@ -361,7 +371,6 @@
       editor_textarea.setToolTipText(Dictionary.get("CDM.FormatManager.Add_Tooltip"));
       
-      JPanel variable_pane = new JPanel();
-      
       variable_combobox = new JComboBox(variable_model.toArray());
+      variable_combobox.setComponentOrientation(Dictionary.getOrientation());
       variable_combobox.setOpaque(!Utility.isMac());
       variable_combobox.setToolTipText(Dictionary.get("CDM.FormatManager.Variable_Tooltip"));
@@ -373,6 +382,8 @@
       JPanel flag_pane = new JPanel();
       enabled_checkbox = new JCheckBox(Dictionary.get("CDM.FormatManager.Enabled"));
+      enabled_checkbox.setComponentOrientation(Dictionary.getOrientation());
       
       JPanel button_pane = new JPanel();
+      button_pane.setComponentOrientation(Dictionary.getOrientation());
       add_button = new GLIButton(Dictionary.get("CDM.FormatManager.Add"), Dictionary.get("CDM.FormatManager.Add_Tooltip"));
       add_button.setEnabled(false);
@@ -418,10 +429,10 @@
       feature_pane.setBorder(BorderFactory.createEmptyBorder(5,0,0,0));
       feature_pane.setLayout(new BorderLayout(5,0));
-      feature_pane.add(feature_label, BorderLayout.WEST);
+      feature_pane.add(feature_label, BorderLayout.LINE_START);
       feature_pane.add(feature_combobox, BorderLayout.CENTER);
       
       part_pane.setBorder(BorderFactory.createEmptyBorder(2,0,0,0));
       part_pane.setLayout(new BorderLayout(5, 0));
-      part_pane.add(part_label, BorderLayout.WEST);
+      part_pane.add(part_label, BorderLayout.LINE_START);
       part_pane.add(part_combobox, BorderLayout.CENTER);
       
@@ -434,8 +445,11 @@
       
       JPanel rupanel = new JPanel();
+      rupanel.setComponentOrientation(Dictionary.getOrientation());
       rupanel.setLayout(new GridLayout(1,2));
       rupanel.add(undo_button);
       rupanel.add(redo_button);
       
+      JPanel variable_pane = new JPanel();
+      variable_pane.setComponentOrientation(Dictionary.getOrientation());
       variable_pane.setBorder(BorderFactory.createEmptyBorder(2,0,2,0));
       variable_pane.setLayout(new GridLayout(1,3));
Index: /gli/trunk/src/org/greenstone/gatherer/cdm/SearchMetadataManager.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/cdm/SearchMetadataManager.java	(revision 18413)
+++ /gli/trunk/src/org/greenstone/gatherer/cdm/SearchMetadataManager.java	(revision 18414)
@@ -207,4 +207,6 @@
 	public SearchMetadataTable() {
 	    // create the model
+	  this.setComponentOrientation(Dictionary.getOrientation());
+	  
 	    model = new SearchMetadataTableModel();
 	    setModel(model);