Index: /gsdl/trunk/macros/german2.dm
===================================================================
--- /gsdl/trunk/macros/german2.dm	(revision 18432)
+++ /gsdl/trunk/macros/german2.dm	(revision 18432)
@@ -0,0 +1,284 @@
+# this file must be UTF-8 encoded
+######################################################################
+#
+# Language text and icon macros 
+# -- this file contains text that is of less importance
+######################################################################
+
+######################################################################
+# 'home' page
+package home
+######################################################################
+
+#------------------------------------------------------------
+# text macros
+#------------------------------------------------------------
+
+### taken from here
+
+_textdescrselcol_ [l=de] {eine Sammlung auswÃ€hlen}  
+
+######################################################################
+# home help page
+package homehelp
+######################################################################
+
+#------------------------------------------------------------
+# text macros
+#------------------------------------------------------------
+
+_text1coll_ [l=de] {Diese Greenstone-Installation enthÃ€lt 1 Sammlung}  
+
+######################################################################
+# external link package
+package extlink
+######################################################################
+
+#------------------------------------------------------------
+# text macros
+#------------------------------------------------------------
+
+# should have arguments of collection, collectionname and link
+
+######################################################################
+# authentication page
+package authen
+######################################################################
+
+#------------------------------------------------------------
+# text macros
+#------------------------------------------------------------
+
+_textmessagedisabled_ [l=de] {Verzeihung, Ihr Account wurde deaktiviert. Bitte kontaktieren Sie den Webmaster dieser Seite.}  
+
+_textmessagepermissiondenied_ [l=de] {Verzeihung, Sie haben keine Zugangserlaubnis zu dieser Seite.}  
+
+######################################################################
+# 'docs' page 
+package docs
+######################################################################
+
+#------------------------------------------------------------
+# text macros
+#------------------------------------------------------------
+
+_textpaperguide_ [l=de] {Von Papier zur Sammlung}  
+_textorganizerguide_ [l=de] {Benutzung des Organizers}  
+
+######################################################################
+# collectoraction
+package wizard
+
+_textseconds_ [l=de] {"seconds"}  
+
+_textfailmsg21_ [l=de] {Die Sammlung konnte nicht erstellt werden (import.pl scheiterte).}  
+
+######################################################################
+# collectoraction
+package collector
+######################################################################
+
+#------------------------------------------------------------
+# text macros
+#------------------------------------------------------------
+
+_textbuildingcollection_ [l=de] {Sammlung aufbauen ...}  
+
+_textswts_ [l=de] {Angeben, woher die Quelldaten kommen}  
+
+_texttfsiw_ [l=de] {Im vierten Schritt erledigt der Computer die ganze Arbeit. Im "Aufbau"-Prozess erzeugt er alle Indexe und sammelt alle ÃŒbrigen Informationen, die benÃ¶tigt werden, damit alles funktioniert. Aber zuerst mÃŒssen Sie die Informationen spezifizieren.}  
+
+_textadab_ [l=de] {Unten wird ein Diagramm angezeigt, auf dem Sie verfolgen kÃ¶nnen, wo Sie sind. Klicken Sie den grÃŒnen Knopf an, um in der Sequenz fortzufahren. Wenn Sie einen Teil der Sequenz durchlaufen haben, erscheinen die entsprechenden KnÃ¶pfe in gelb. Sie kÃ¶nnen zu einer vorhergehenden Seite zurÃŒckkehren, indem Sie den entsprechenden gelben Knopf anklicken.}  
+
+_textcnmbs_ [l=de] {Der Name der Sammlung muss angegeben werden}  
+_texteambs_ [l=de] {Emailadresse muss angegeben werden}  
+
+_textwcanc_ [l=de] {Um eine neue Sammlung anzulegen, mÃŒssen zuerst einige Informationen ÃŒber die Quelldaten eingegeben werden. Dieser Prozess ist als eine Folge von Webseiten angelegt, die von "Dem Sammler" ÃŒberwacht wird. Der Balken am unteren Ende der Seite zeigt Ihnen an, welche Webseiten noch zu durchlaufen sind.}  
+
+_texttctiasp_ [l=de] {Der Titel der Sammlung ist eine kurze Phrase, die in der gesamten Digitalen Bibliothek benutzt wird um den Inhalt der Sammlung zu identifizieren. Beispieltitel sind "Computer Science Technical Reports" und "Humanity Development Library".}  
+
+_textatc_ [l=de] {Ãber diese Sammlung:}  
+
+_textbtco_ [l=de] {Die Sammlung basieren auf}  
+
+_textdelsuc_ [l=de] {Die Sammlung _cgiargbc1dirname_ wurde erfolgreich gelÃ¶scht.}  
+
+######################################################################
+# depositoraction
+package depositor
+######################################################################
+
+_textcaec_ [l=de] {Vorhandene Sammlung ergÃ€nzen}  
+
+_textselect_ [l=de] {Sammlung auswÃ€hlen}  
+
+######################################################################
+# 'gsdl' page
+package gsdl
+######################################################################
+
+#------------------------------------------------------------
+# text macros
+#------------------------------------------------------------
+
+_textgreenstone3_ [l=de] {Greenstone lÃ€uft auf Windows, Unix und Mac OS X. Die Distribution enthÃ€lt betriebsfertige BinÃ€rdateien fÃŒr alle Versionen von Windows und fÃŒr Linux und Mac OS X. Sie enthÃ€lt auch den vollstÃ€ndigen Quellcode des Systems, welcher mit Microsoft C++ oder gcc kompiliert werden kann. Greenstone arbeitet mit assoziierter Software, die ebenfalls frei erhÃ€ltlich ist: der Apache-Webserver und PERL. Die BenutzeroberflÃ€che nutzt einen Webbrowser: normalerweise Netscape Navigator oder Internet Explorer.}  
+
+#_textthreedocs_ {There are three documents that explain the Greenstone system:}
+#_textinstall_ {The Greenstone Digital Library Software Installer's Guide}
+#_textuser_ {The Greenstone Digital Library Software User's Guide}
+#_textdevelop_ {The Greenstone Digital Library Software Developer's Guide}
+
+_textmailinglist_ [l=de] {Es gibt eine Mailingliste, die der Diskussion ÃŒber die Digitale-Bibliotheks-Software von Greenstone dienen soll. Aktiven Nutzern von Greenstone wird vorgeschlagen, der Mailingliste beizutreten und an den Diskussionen teilzunehmen. Hier kÃ¶nnen Sie sich anmelden: <a href="https://list.scms.waikato.ac.nz/mailman/listinfo/greenstone-users">https://list.scms.waikato.ac.nz/mailman/listinfo/greenstone-users</a>.
+}  
+
+######################################################################
+# 'users' page
+package userslistusers
+######################################################################
+
+#------------------------------------------------------------
+# text macros
+#------------------------------------------------------------
+
+_textadduser_ [l=de] {neuen Benutzer hinzufÃŒgen}  
+
+######################################################################
+# 'users' page
+package usersedituser
+######################################################################
+
+#------------------------------------------------------------
+# text macros
+#------------------------------------------------------------
+
+######################################################################
+# 'users' page
+package usersdeleteuser
+######################################################################
+
+#------------------------------------------------------------
+# text macros
+#------------------------------------------------------------
+
+######################################################################
+# 'users' page
+package userschangepasswd
+######################################################################
+
+#------------------------------------------------------------
+# text macros
+#------------------------------------------------------------
+
+######################################################################
+# 'users' page
+package userschangepasswdok
+######################################################################
+
+#------------------------------------------------------------
+# text macros
+#------------------------------------------------------------
+
+######################################################################
+# 'users' page
+package users
+######################################################################
+
+#------------------------------------------------------------
+# text macros
+#------------------------------------------------------------
+
+######################################################################
+# 'status' pages
+package status
+######################################################################
+
+#------------------------------------------------------------
+# text macros
+#------------------------------------------------------------
+
+_textlistusers_ [l=de] {Benutzer auflisten}  
+
+_textbrowsers_ [l=de] {Browser}  
+_textprotocols_ [l=de] {Protokolle}  
+
+_textusagelog_ [l=de] {Benutzungs-Protokoll}  
+
+######################################################################
+# 'bsummary' pages
+package bsummary
+######################################################################
+
+#------------------------------------------------------------
+# text macros
+#------------------------------------------------------------
+
+_textilog_ [l=de] {Log importieren fÃŒr die Sammlung "_collectionname_" }  
+
+############################################################################
+#
+# This stuff is only used by the usability (SEND FEEDBACK) stuff
+#
+############################################################################
+package Global
+
+# old cusab button
+
+_greenstoneusabilitytext_ [l=de] {Greenstone BenutzerfÃŒhrung}  
+
+_textsend_ [l=de] {Absenden}  
+
+_texttrackreport_ [l=de] {Diesen Report verfolgen}  
+
+ 
+
+_textcritical_ [l=de] {Bedenklich}  
+_textmajor_ [l=de] {Gravierend}  
+
+_textusabbanner_ [l=de] {das Greenstone-Banner im Koru-Stil}  
+
+######################################################################
+# GTI text strings
+package gti
+######################################################################
+
+#------------------------------------------------------------
+# text macros
+#------------------------------------------------------------
+	
+
+_textgtihome_ [l=de] {Diese Seiten helfen Ihnen, die mehrsprachige SprachunterstÃŒtzung von Greenstone zu verbessern. Sie kÃ¶nnen
+<ul>
+  <li>Teile von Greenstone in eine neue Sprache ÃŒbersetzen
+  <li>eine existierende SprachoberflÃ€che aktualisieren, wenn sich die englische SprachoberflÃ€che Ã€ndert (z.B. fÃŒr neue Greenstone-Facilities)
+  <li>Fehler in existierenden Ãbersetzungen korrigieren
+</ul>
+
+Sie bekommen eine Reihe von Webseiten zu sehen. Jede Webseite enthÃ€lt eine Phrase, die Sie ÃŒbersetzen. Das heiÃt, Sie ÃŒbersetzen das Sprachinterface Phrase fÃŒr Phrase.
+Viele Phrasen enthalten Kommandos im HTML-Format: Diese sollen nicht ÃŒbersetzt, sondern vollstÃ€ndig ÃŒbernommen werden. WÃ¶rter, die mit Unterstrichen versehen sind (wie _dieses_) sollen auch nicht ÃŒbersetzt werden (es sind Greenstone "Macro"-Namen).
+<p>
+Wenn Sie eine existierende SprachoberflÃ€che aktualisieren, werden Ihnen keine Phrasen gezeigt, fÃŒr die es schon eine Ãbersetzung gibt. Manchmal existiert eine Ãbersetzung, aber der englische Text wurde geÃ€ndert. In diesem Fall wird die derzeitige Ãbersetzung gezeigt, und Sie sollten prÃŒfen, ob eine Aktualisierung notwendig ist.
+<p>
+Um eine Ãbersetzung zu korrigieren, die schon aktualisiert wurde, verwenden Sie die Einrichtung "Vorhandene Ãbersetzungen korrigieren", die es fÃŒr jeden Teil von Greenstone gibt.
+<p>
+Jede Seite endet mit einem "_textgtisubmit_" Knopf. Wenn Sie den Knopf betÃ€tigen, werden die Ãnderungen sofort in einer separaten Greenstone-Installation auf nzdl.org durchgefÃŒhrt. Auf jeder Seite ist ein Knopf vorhanden, um diese Webseite anzusehen.
+}  
+
+_textgtiselecttlc_ [l=de] {Bitte wÃ€hlen Sie Ihre Sprache}  
+
+#for status page
+
+_textgtigs3core_ [l=de] {Greenstone3 BenutzeroberflÃ€che (Default)}  
+
+#for greenstone manuals
+
+_textgtipapermanual_ [l=de] {Greenstone Anleitung fÃŒr Papier zur Sammlung}  
+
+#for status page
+
+_textgtilastupdated_ [l=de] {Zuletzt aktualisiert}  
+
+############
+# gli page
+############
+package gli
+